import java.io.*;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.*;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.*;
import org.w3c.dom.Document;

public class Transform
{

   public static void main(String[] args) throws Exception
   {

      String input = args[0];
      String template = args[1];
      String output = args[2];

      ByteArrayOutputStream buff = new ByteArrayOutputStream();
      TransformerFactory factory = TransformerFactory.newInstance();
      Transformer xformer = null;

      Templates xsl_template = factory.newTemplates(new StreamSource(new FileInputStream(template)));
      xformer = xsl_template.newTransformer();

      Document doc = loadSourceDoc(input);
      Source source = new DOMSource(doc);

      Result result = new StreamResult(buff);
      xformer.transform(source, result);

      FileOutputStream fos = new FileOutputStream(output);
      fos.write(buff.toByteArray());
      fos.close();

   }

   private static Document loadSourceDoc(String fileName) throws Exception
   {
      ByteArrayOutputStream ba = new ByteArrayOutputStream();
      FileInputStream fis = new FileInputStream(fileName);

      byte[] data = new byte[1024];
      int read = fis.read(data, 0, 1024);
      while(read > -1)
      {
          ba.write(data, 0, read);
          read = fis.read(data, 0, 1024);
      }
      fis.close();

      DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
      DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
      ByteArrayInputStream reader = new ByteArrayInputStream(ba.toByteArray());
      Document doc = docBuilder.parse(reader);

      return doc;
   }
}
